void commencelivre() {
  float covert=random(10, mov.duration());
  jumpmovto(covert);
  println("cover image at "+covert);
  
  float[] tt=calcul_largeur(nomfilm.toUpperCase(), coverTitleFont, 60, width-(margin[1]+margin[3] *2 ));

  textFont(coverTitleFont, tt[0]);
  textLeading(tt[1]*1.2);
  fill(coverColor);
  text(nomfilm.toUpperCase(), margin[0], height*0.15, width-(margin[1]+margin[3] *2 ), tt[1]*3);

  float illu[]=dimensions(mov, width-(margin[0]*3), height/2);

  image(getImage(covert), margin[0]*1.5, height*0.40, illu[0], illu[1]);

  textFont(coverTitleFont, 44);
  text(realisateur, margin[0], height*0.81, width-(margin[0]*2), 82);

  textFont(coverTextFont, 32);
  text(ladate, margin[0], height*0.85, width-(margin[0]*2), 64);

  textFont(coverTitleFont, 21);
  text(edition, margin[0], height*0.94, width-(margin[0]*2), 32);

  pdf.nextPage();
}

void finitlivre() {

  float p=mov.time();
  bas_de_page(page);

  // page arrière
  pdf.nextPage();
  fill(coverColor);
  textFont(coverTextFont, 26);
  textAlign(LEFT);
  textLeading(38);
  text(resume, margin[0]*2, height*0.32, width-(margin[0]*4), height*0.55);

  textFont(coverTextFont, 16);
  textAlign(CENTER);
  text(hrf, margin[0], height*0.93, width-(margin[0]*2), 20);

  textFont(coverTextFont, 21);
  text(edition, margin[0], height*0.95, width-(margin[0]*2), 32);
  endRecord();
  exit();
}

float[] calcul_largeur(String texte, PFont police, int taille_min, int largeur) {
  boolean ok=false;
  while (ok==false) {
    textFont(police, taille_min+1);
    if (textWidth(texte) > largeur) {
      ok=true;
    } else {
      taille_min++;
    }
  }
  float scalar = 0.8;
  float h=textAscent() + textDescent();
  float[] r= {
    taille_min*1.0, h
  };
  return r;
}

float[] dimensions(PImage limage, float tailledw, float tailledh) {
  int largeur=limage.width;
  int hauteur=limage.height;

  float nw=tailledw;
  float nh;
  nh=hauteur/(largeur*1.0/tailledw);

  float[] d = {
    nw, nh
  };
  return d;
}

void bas_de_page(int p) {
  // numero de page
  // afficher le temps
  int temps=int(mov.time());
  int s=temps % 60;
  int m=(temps / 60) % 60;
  int h=(temps/3600) % 24;
  fill(0);
  textFont(coverTextFont, 11);
  text("( page "+p+" / "+nf(h, 2)+":"+nf(m, 2)+":"+nf(s, 2)+"  )", width/2, height-(margin[2]*0.66));
}
